//+------------------------------------------------------------------+
//|                                            SV3.mq5 |
//|                              |
//|                              |
//+------------------------------------------------------------------+
#property copyright "2010,"
#property link      "http://login.mql5.com"
#property version   "1.00"
#property indicator_separate_window
#property indicator_plots   5  //must set, can be bigger than necessary, can not be bigger than indicator_buffers
#property indicator_buffers 5 //must set, can be bigger than necessary
                                                //BufferPattern
#property indicator_type1   DRAW_COLOR_CANDLES  //DDDDC
#property indicator_type2   DRAW_ARROW          //D
#property indicator_type3   DRAW_ARROW          //D
#property indicator_type4   DRAW_COLOR_ZIGZAG   //DDC
//#property indicator_type5   DRAW_COLOR_LINE     //DC
#property indicator_color1  Blue,Black
#property indicator_color2  Black
#property indicator_color3  Black
#property indicator_color4  Black
#property indicator_color5  Black

//--- input parameters

input int ExtPeriod=10;
//--- input parameters from ZigzagColor.mq5
input int ExtDepth=12;
input int ExtDeviation=5;
input int ExtBackstep=3;
int level=3; // recounting's depth 

double P1B1[];   //  data buffer
double P1B2[];
double P1B3[];
double P1B4[];
double P1BC[];   // color buffer

double P2B1[];   //  data buffer
double P3B1[];   //  data buffer

double P4B1[];   //  data buffer
double P4B2[];   //  data buffer
double P4BC[];   // color buffer
double P4M1[];   //  calc buffer
double P4M2[];   //  calc buffer

double P5B1[];   //  data buffer
double P5BC[];   // color buffer

//--- 10 pixels upper from high price
int    iArrowShift=10;
int    maHandle;
int i;
int    x;
int    z;
int    y;
int    r;
int    f;
int    a;
double    g;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   SetIndexBuffer( 0,P1B1,INDICATOR_DATA);
   SetIndexBuffer( 1,P1B2,INDICATOR_DATA);
   SetIndexBuffer( 2,P1B3,INDICATOR_DATA);
   SetIndexBuffer( 3,P1B4,INDICATOR_DATA);
   SetIndexBuffer( 4,P1BC,INDICATOR_COLOR_INDEX);
 
//--- They should be placed after all the buffer to be displayed, or else ... you can try it by youself

//--- ARROW
   PlotIndexSetInteger(1,PLOT_ARROW,217);
   PlotIndexSetInteger(2,PLOT_ARROW,218);
   PlotIndexSetInteger(1,PLOT_ARROW_SHIFT,-iArrowShift);
   PlotIndexSetInteger(2,PLOT_ARROW_SHIFT,iArrowShift);
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,EMPTY_VALUE);
   PlotIndexSetDouble(2,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//--- ZIGZAG
   PlotIndexSetDouble(3,PLOT_EMPTY_VALUE,0.0);
//--- MA
 //  maHandle=iMA(Symbol(),0,ExtPeriod,0,MODE_EMA,PRICE_CLOSE);

   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime& time[],
                const double& open[],
                const double& high[],
                const double& low[],
                const double& close[],
                const long& tick_volume[],
                const long& volume[],
                const int& spread[])
                
  {

//---
   CalcCandles(rates_total,prev_calculated,open,high,low,close,time);
 //CalcColorMA(rates_total,prev_calculated,P5B1,P5BC);
   return(rates_total);
  }
//+------------------------------------------------------------------+
int CalcCandles(const int rates_total,
                const int prev_calculated,
                const double& open[],
                const double& high[],
                const double& low[],
                 
                const double& close[],
                const datetime &time[])
         
  {
 //      Print(rates_total); 
//--- auxiliary variables
  int i=110;
   z=0;
  r=0;
   f=0;
   g=0;
     x=0;
//--- set position for beginning
 //  if(i<prev_calculated) i=prev_calculated-1;
   
//--- set position for beginning
//   if(i<prev_calculated) i=prev_calculated-1;
//--- start calculations
   while(i<rates_total)
     {
   
          if(i>r)
    { 
     r=0;
  //    Print(" [i];^",i);
 //   P1B1[i]=open[i];
      P1B2[i]=high[i];
      P1B3[i]=low[i];
      P1B4[i]=close[i];
      P1BC[i]=(double)((close[i]>open[i])?0:1);
  //      Print(close[i]," close[i];^",i);
  //   if (rates_total-i>250 && rates_total-i<320) 
 //                  {Print(P1B2[i+x]," ^",P1B3[i+x]," ^",low[i]," ^",i," ^",x," ^"," ^",r," ^",time[i+x]);}
          
   if(i<=rates_total)
   { 


               g=0;

               x=0;
               f=0;  
                
               while (high[i]>=P1B2[i-x] && low[i]<=P1B3[i-x])
                 
                {   
                  
                                    
                if(x>=f ) 
                {
                f=x;
              
                  
                P1B2[i-x]=high[i]; 
                   P1B3[i-x]=low[i];
       
   //        if (rates_total-i>250 && rates_total-i<320) 
   //                {Print(P1B2[i-x]," ^",P1B3[i-x],"[i-x] ^",low[i]," ^",i," ^",x," ^"," ^"," ^",time[i-x]);}
                  g=open[i-x];      
                 P1B1[i-x]=open[i-x];
                    P1B4[i-x]=close[i];
                 P1BC[i-x]=(double)((P1B4[i-x]>P1B1[i-x])?0:1);     
                   }
                   a=x;
                 for(y=0;y<=a; y++)
                 {P1B1[i-y]=P1B1[i-x];
                 P1BC[i-x]=(double)((P1B4[i-x]>P1B1[i-y])?0:1);}
                 x++;   
                   } 
              
            f=0;
              z=0;
               x=0;
                  
             while  ((i+x<rates_total) && high[i]>= high [i+x] && low[i]<= low[i+ x])
                 
                {   
                if(x>=f) 
                {
                f=x;
                 z=i+x;
                P1B2[i+x]=high[i]; 
                   P1B3[i+x]=low[i];
                    r=i+x;
  //      if (rates_total-i>250 && rates_total-i<320)   
   //                {Print(P1B2[i+x]," ^",P1B3[i+x],"[i+x] ^",low[i]," ^",i," ^",x," ^",r," ^"," ^",time[i+x]);}
                 if(g!=0) {P1B1[i+x]= g;}    
              else    P1B1[i+x]=open[i];
                 P1B4[i+x]=close[i+x];
                 P1BC[i+x]=(double)((P1B4[i+x]>P1B1[i+x])?0:1);
                 a=x;
                 for(y=0;y<a; y++)
                 {P1B4[i+y]=close[i+x];
                 P1BC[i+y]=(double)((P1B4[i+y]>P1B1[i+x])?0:1);}
                   }
                 x++; 
                  
                 
                   }
          }
       
                   }
      i++;
     }
//--- return value of prev_calculated for next call
   return(rates_total);
  }


